<hny-select>
<select id="{id}" style="{style}" name="{name}" class="{css}" val="{ opts.val }" data-group="{dataGroup}" data-idx="{dataIdx}" onclick="{ onclickfunc }" onchange="{ selectChangeHandler }" onfocus={focusFunc} onblur={blurFunc}>
	<option if={ hasblank } value="">{ alllabel }</option>
	<option each={obj in list} value="{obj.code}" selected={isselected(obj.code)}>{obj.meisyo}</option>
</select>
<message tagid="{messageid}" msgstyle="{msgstyle}"></message>
<script>
	this.id = opts.tagid;
	this.name = (opts.name) ? opts.name : opts.tagid;
	this.list = opts.list;
	this.messageid = opts.tagid + "MessageDiv";
	this.val = opts.val;
	this.dataGroup = opts.dataGroup;
	this.dataIdx = opts.dataIdx;
	this.style = (opts.style ? opts.style : "");
	this.css = "bakyel " + (opts.css ? opts.css : "");
	this.onchangefunc = (opts.onchangefunc) ? opts.onchangefunc : null;
	this.msgstyle = opts.msgstyle;

	this.hasblank = opts.hasblank;
	this.alllabel = opts.alllabel ? opts.alllabel : "";
	
	selectChangeHandler(e) {
		e.preventUpdate = true;
		var selectedValue = $('#' + this.id).val();
		var item = {};
		for (var idx = 0; idx < this.list.length; idx ++) {
			var obj = this.list[idx];
			if (obj.code == selectedValue) {
				item = obj;
				break;
			}
		}
		$('#' + this.id).data('entity', item);
		if (opts.onchangefunc != null) {
			opts.onchangefunc(e);
		}
	}

	this.on('mount', function() {
		isselected(tgtval){
			if (tgtval == this.val) {
				return "selected";
			} else {
				return "";
			}
		}
	});

	// フォーカスin時の値を保持
	this._tmpVal = this.value;
	
	/**
	 * フォーカスin時の処理
	 */
	focusFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this._tmpVal = $('#' + this.id).val();
	}

	/**
	 * フォーカスout時の処理
	 */
	blurFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		var aftVal = $('#' + this.id).val();
		if (this._tmpVal != aftVal) {
			updFlg = true;
			$('#' + this.id).attr('data-updflg', '1');
		}
	}

	/**
	 * マウント時の処理
	 */
	this.on('updated', function() {
		setDataObj(opts.tagid, opts);
	});
	
	/**
	 * キーがデータ属性に使用するキーかどうか
	 */
	function isDataAttrKey(key) {
		return key.startsWith('data-');
	}
	
	/**
	 * データ属性を設定する
	 */
	function setDataObj(id, val, forcingFlg) {
		Object.keys(val).forEach(function(key) {
			if (isDataAttrKey(camelToSnake(key, '-')) || forcingFlg) {
				var v = val[key];
				if (typeof v === 'object') {
					setDataObj(id, v, true);
				} else {
					$('#' + id).attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
				}
			}
		});
	}
</script>
</hny-select>
